<script setup>
import { ref, toRef, watch } from "vue";
import { useField } from "vee-validate";
import { BFormInput, BInputGroupAppend, BInputGroup } from "bootstrap-vue";
const props = defineProps({
  type: {
    type: String,
    default: "text",
  },
  value: {
    type: String,
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: null,
  },
  autofocus: {
    type: Boolean,
    default: false,
  },
  name: {
    type: String,
    required: true,
  },
  maxlength: {
    type: Number,
    default: 1000000,
  },
  label: {
    type: String,
    required: true,
  },
  successMessage: {
    type: String,
    default: "",
  },
  placeholder: {
    type: String,
    default: "",
  },
  autofocus: {
    type: Boolean,
    default: false,
  },
});

// use `toRef` to create reactive references to `name` prop which is passed to `useField`
// this is important because vee-validte needs to know if the field name changes
// https://vee-validate.logaretm.com/v4/guide/composition-api/caveats
const name = toRef(props, "name");
const value = toRef(props, "value");

watch([value], () => {
  setValue(value.value);
});

// we don't provide any rules here because we are using form-level validation
// https://vee-validate.logaretm.com/v4/guide/validation#form-level-validation
const {
  value: inputValue,
  errorMessage,
  handleBlur,
  handleChange,
  setValue,
  meta,
} = useField(name, undefined, {
  initialValue: props.value,
});
const emit = defineEmits(["change"]);
function changedValue(params) {
  emit("change", params);
}

const passwordFieldType = ref("password");
const togglePasswordVisibility = () => {
  passwordFieldType.value = passwordFieldType.value === "password" ? "text" : "password";
};
</script>

<template>
  <div
    class="PasswordInput"
    :class="{ 'is-invalid': !!errorMessage, success: meta.valid }"
  >
    <label for="login-password" v-if="label"
      >{{ label }} <span class="text-danger"> *</span></label
    >

    <BInputGroup
      class="input-group-merge"
      :class="errorMessage && errorMessage.length > 0 ? 'is-invalid' : null"
    >
      <BFormInput
        ref="input"
        maxlength="30"
        :autofocus="autofocus"
        :state="errorMessage ? false : null"
        :name="name"
        :id="name"
        :type="passwordFieldType"
        :value="value"
        :placeholder="placeholder"
        :disabled="disabled"
        @input="handleChange"
        @blur="handleBlur"
        @change="changedValue"
      />

      <BInputGroupAppend is-text @click="togglePasswordVisibility">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          v-if="passwordFieldType === 'password'"
          width="14px"
          height="14px"
          viewBox="0 0 24 24"
          fill="none"
          stroke="currentColor"
          stroke-width="2"
          stroke-linecap="round"
          stroke-linejoin="round"
          class="feather feather-eye-off cursor-pointer"
          size="14px"
        >
          <path
            d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"
          ></path>
          <line x1="1" y1="1" x2="23" y2="23"></line>
        </svg>
        <svg
          xmlns="http://www.w3.org/2000/svg"
          v-if="passwordFieldType != 'password'"
          width="14px"
          height="14px"
          viewBox="0 0 24 24"
          fill="none"
          stroke="currentColor"
          stroke-width="2"
          stroke-linecap="round"
          stroke-linejoin="round"
          class="feather feather-eye cursor-pointer"
          size="14px"
        >
          <path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path>
          <circle cx="12" cy="12" r="3"></circle>
        </svg>
        <!-- <FeatherIcon class="cursor-pointer" :icon="newPasswordToggleIcon" /> -->
      </BInputGroupAppend>
    </BInputGroup>
    <small class="text-danger" v-if="errorMessage">{{ errorMessage }}</small>
  </div>
</template>

<style scoped scss>
/* .has-error .form-control {
  background-image: url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='red'%3E%3Ccircle cx='6' cy='6' r='4.5'/%3E%3Cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3E%3Ccircle cx='6' cy='8.2' r='.6' fill='%23a4c008' stroke='none'/%3E%3C/svg%3E") !important;
  background-repeat: no-repeat;
  background-size: calc(.725em + .438rem) calc(.725em + .438rem)
}
.has-error .form-control:focus {
  background-image: url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='red'%3E%3Ccircle cx='6' cy='6' r='4.5'/%3E%3Cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3E%3Ccircle cx='6' cy='8.2' r='.6' fill='%23a4c008' stroke='none'/%3E%3C/svg%3E");
  background-repeat: no-repeat;
  background-size: calc(.725em + .438rem) calc(.725em + .438rem)
} */
</style>
